<!--
  * 收货地址
  *
  * @Author:    hj
  * @Date:      2024-12-26 15:35:23
  * @Copyright  友仓
-->
<template>
  <a-modal
      :title="form.addressId ? '编辑地址' : '添加地址'"
      :width="600"
      :open="visibleFlag"
      @cancel="onClose"
      :maskClosable="false"
      :destroyOnClose="true"
  >
    <a-form ref="formRef" :model="form" :rules="rules" :label-col="{ span: 5 }" >

        <a-form-item label="收货单位"  name="name">
          <a-input style="width: 100%" v-model:value="form.name" placeholder="收货单位" />
        </a-form-item>
        <a-form-item label="联系人"  name="person">
          <a-input style="width: 100%" v-model:value="form.person" placeholder="联系人" />
        </a-form-item>
        <a-form-item label="电话"  name="telephone">
          <a-input style="width: 100%" v-model:value="form.telephone" placeholder="电话" />
        </a-form-item>
      <a-form-item label="地址" name="address">
        <a-textarea v-model="form.address" style="width: 100%; height: 100px; outline: none" />
      </a-form-item>
    </a-form>

    <template #footer>
      <a-space>
        <a-button @click="onClose">取消</a-button>
        <a-button type="primary" @click="onSubmit">保存</a-button>
      </a-space>
    </template>
  </a-modal>
</template>
<script setup lang="ts">
  import { reactive, ref, nextTick } from 'vue';
  import _ from 'lodash';
  import { message } from 'ant-design-vue';
  import { SmartLoading } from '/@/components/framework/smart-loading';
  import { addressApi } from '/@/api/business/base/address/address-api';
  import { smartSentry } from '/@/lib/smart-sentry';

  // ------------------------ 事件 ------------------------

  const emits = defineEmits(['reloadList']);

  // ------------------------ 显示与隐藏 ------------------------
  // 是否显示
  const visibleFlag = ref(false);

  function show(rowData) {
    Object.assign(form, formDefault);
    if (rowData && !_.isEmpty(rowData)) {
      Object.assign(form, rowData);
    }
    // 使用字典时把下面这注释修改成自己的字典字段 有多个字典字段就复制多份同理修改 不然打开表单时不显示字典初始值
    // if (form.status && form.status.length > 0) {
    //   form.status = form.status.map((e) => e.valueCode);
    // }
    visibleFlag.value = true;
    nextTick(() => {
      formRef.value.clearValidate();
    });
  }

  function onClose() {
    Object.assign(form, formDefault);
    visibleFlag.value = false;
  }

  // ------------------------ 表单 ------------------------

  // 组件ref
  const formRef = ref();

  const formDefault = {
      addressId: undefined, //收货地址id
      name: undefined, //名称/单位
      person: undefined, //联系人
      telephone: undefined, //电话
      address: undefined, //地址
  };

  let form = reactive({ ...formDefault });

  const rules = {
      addressId: [{ required: true, message: '收货地址id 必填' }],
  };

  // 点击确定，验证表单
  async function onSubmit() {
    try {
      await formRef.value.validateFields();
      await save();
    } catch (err) {
      message.error('参数验证错误，请仔细填写表单数据!');
    }
  }

  // 新建、编辑API
  async function save() {
    SmartLoading.show();
    try {
      if (form.addressId) {
        await addressApi.update(form);
      } else {
        await addressApi.add(form);
      }
      message.success('操作成功');
      emits('reloadList');
      onClose();
    } catch (err) {
      smartSentry.captureError(err);
    } finally {
      SmartLoading.hide();
    }
  }

  defineExpose({
    show,
  });
</script>
